/* replace all "127.0.0.1 to ip address */
/* pluto is on Road Warrior side */

void
rw_replace_address (unsigned long rw_addr) {
    struct secret *s;
    unsigned long localh = inet_addr ("127.0.0.1");
    unsigned int found = 0;
    struct in_addr t;
    char rws[64];

    t.s_addr = rw_addr;
    strcpy (rws, inet_ntoa (t));
    log ("replacing entries in secrets table 127.0.0.1 -> %s", rws);
    for (s = secrets; s != NULL; s = s->next) {
    	struct secret_index *i;

      for (i = s->indices; i != NULL; i = i->next) {
        switch (i->type) {
  	      case ID_IPV4_ADDR:
          	if (localh == i->ipv4.s_addr) {
                  i->ipv4.s_addr = rw_addr;
                  found++;
      	    }
      	    break;
	      }
    	}
    }
    log ("%d occurances replaced", found);
}

int replace_preshared_secret(unsigned long this, unsigned long that, char *password, int passlen) {
    struct secret *s;

    for (s = secrets; s != NULL; s = s->next)
    {
	unsigned int found = 0;
	struct secret_index *i;

	for (i = s->indices; i != NULL; i = i->next)
	{
	    switch (i->type)
	    {
	    case ID_IPV4_ADDR:
		if (this == i->ipv4.s_addr)
		    found |= 01;
		if (that == i->ipv4.s_addr)
		    found |= 02;
		break;
	    }
	    if (found == (01 | 02))
	    {
		/* both ends matched: success */
                pfree (s->secret.ptr);
                clonetochunk(s->secret, password, passlen, "secret text");
		log ("password replaced");
	    }
	}
    }
    return 0;
}


